\section{Regression tests}
\label{sec:reg_tests}

This section describes the scope and design of current regression tests\footnote{In our case, a regression test reruns a know piece of code which creates a specific data output. This data output is then referenced against a nominal and {\it correct} data output which is stored in the associated test {\it dependencies} folder.} for the SPIIR pipeline. Depending on which area of the codebase you are working on, you wil l have to include the pass result to your GitLab Merge Request. The current tests tackle 3 major areas of the codebase:

\begin{enumerate}
    \item Source detection
    \item Source localisation
    \item Template bank generation
\end{enumerate}


\hrulefill \\


{\bf A critical component of this infrastructure is that you have built and developed your code into a branch using the build process described in appendix section B of the {\it SPIIR\_induction\_manual}. \\}


\hrulefill

\subsection{Source detection:\newline unit\_testing.create.trigger\_comparison()}
\label{sec:trigger_comparison}

The purpose of this regression test is to identify if newly written code introduces variations in the identified GW170817 source parameters. You can preview the code documentation in section \ref{sec:unit_testing_trigger_comparison}. This test is fairly lightweight and can be run on the OzStar head node. However, if that is not the case, there instructions in the {\it run\_gw170817\_offline.sh} script located in the {\it unit\_testing} directory. As the name of the file implies, {\bf this test does not have an online component}.


The scope of the test is under the {\bf gstlal\_inspiral\_postcohspiir\_online} system function. One of the outputs of this test is a {\it zerolag} file. A .csv file is created from this file and this .csv file is then compared to baseline file. The comparison is done by {\it unit\_testing.base.compare\_zerolag\_trigger\_files()} and the associated docstring can be viewed in section \ref{sec:unit_testing_compare_zerolag_trigger_files}. This comparison checks for variations of no more than 0.00001 in the values denoted in the {\it reference\_keys} column of the {\it unit\_testing\textbackslash dependencies\textbackslash reference\_keys.csv} file. This threshold value can be changed and new keys can be added by simply modifying this .csv file. \\

This test simply returns a bool.

\subsection{Source localisation:\newline unit\_testing.create.skymap\_comparison()}
\label{sec:skymap_comparison}

The associated docstring can be viewed in section \ref{sec:unit_testing_skymap_comparison}

\subsection{Template bank generation: \newline unit\_testing.create.bank\_generation\_comparison()}
\label{sec:bg_comparison}

The purpose of this regression test is to identify if newly written code impacts the SPIIR parameters associated with each template in bank 3. This bank is chosen simply because it is the same bank used in section \ref{sec:trigger_comparison}. The associated docstring can be seen in section \ref{sec:unit_testing_bank_generation_comparison}. This test is a {\it wrapper} and submits a SLURM job for the {\it unit\_testing\textbackslash dependencies\textbackslash bank\_generation\textbackslash build\_and\_compare\_new\_bank.py} file. The scope of this test is {\bf gstlal.spiirbank.cbc\_template\_iir.bank.build\_from\_tmpltbank()} and any changes to the codebase outside of this test but related to bank generation might not be captured by this test.


This test first creates a new bank based on the passed IFO, latency variables. Following this, the templates of this same bank are iterated through and compared to the corresponding templates from a reference bank. A template comparison fails if the difference between any of the ['a1', 'b0', 'd'] parameters is greater than a percentage threshold. The default value of that threshold is currently set to 5\%. Overall, a regression test passes if less than 100 templates fail. The current number of templates in a bank is 1000. This number of failed templates can be changed by adjusting the number\_of\_allowed\_bad\_templates variable in {\it unit\_testing\textbackslash dependencies\textbackslash bank\_generation\textbackslash build\_and\_compare\_new\_bank.py} file. \\

This test creates several files in the user's home directory and the PASS/FAIL .txt is of the form:


-- bg\_comparison\_IFO\_{ifo}\_latency\_{latency integer value}\_{spiir branch name}\_{PASS/FAIL result}.txt

The 'PASS' version of this .txt needs to be attached to the MERGE REQUEST for the relevant spiir branch.